# Contributing guidelines

## How to become a contributor and submit your own code

### Contributor License Agreements

We'd love to accept your patches! Before we can take them, we have to jump a couple of legal hurdles.

Please fill out either the individual or corporate Contributor License Agreement (CLA).

  * If you are an individual writing original source code and you're sure you own the intellectual property, then you'll need to sign an [individual CLA](https://gist.github.com/TamalSaha/ae971bf97adb6c754737cdf286576f36).
    * If you work for a company that wants to allow you to contribute your work, then you'll need to sign a [corporate CLA](https://gist.github.com/TamalSaha/319266b48257572414af52103b66fef3).

Follow either of the two links above to access the appropriate CLA. For individual CLA, you can sign via https://cla-assistant.io/. For corporate CLA, please download and sign the CLA and send it to us via email to support AT appscode.com. Once we receive it, we'll be able to accept your pull requests.

***NOTE***: Only original source code from you and other people that have signed the CLA can be accepted into the main repository.

### Contributing A Patch

1. Submit an issue describing your proposed change to the repo in question.
1. The repo owner will respond to your issue promptly.
1. If your proposed change is accepted, and you haven't already done so, sign a Contributor License Agreement (see details above).
1. Fork the desired repo, develop and test your code changes.
1. Submit a pull request.
